Clazz.declarePackage ("JS");
Clazz.load (["JU.P3"], "JS.SpaceGroupFinder", ["java.lang.Float", "JU.BS", "$.Lst", "JS.SpaceGroup", "$.SymmetryOperation", "JU.BSUtil", "$.SimpleUnitCell", "JV.FileManager"], function () {
c$ = Clazz.decorateAsClass (function () {
this.atoms = null;
this.nAtoms = 0;
this.pt = null;
if (!Clazz.isClassDefined ("JS.SpaceGroupFinder.SGAtom")) {
JS.SpaceGroupFinder.$SpaceGroupFinder$SGAtom$ ();
}
Clazz.instantialize (this, arguments);
}, JS, "SpaceGroupFinder");
Clazz.prepareFields (c$, function () {
this.pt =  new JU.P3 ();
});
Clazz.makeConstructor (c$, 
function () {
});
Clazz.defineMethod (c$, "findSpaceGroup", 
function (vwr, atoms0, opXYZ0, uc, asString) {
var cartesians = vwr.ms.at;
var isg = 0;
var bsGroups =  new JU.BS ();
var bsOps =  new JU.BS ();
var bsAtoms = null;
var bsPoints0 =  new JU.BS ();
if (opXYZ0 == null) {
bsAtoms = JU.BSUtil.copy (atoms0);
this.nAtoms = bsAtoms.cardinality ();
}var targets = JU.BS.newN (this.nAtoms);
var n = 0;
var nChecked = 0;
var scaling = JU.P3.new3 (1, 1, 1);
var withinCell = null;
try {
if (JS.SpaceGroupFinder.bsOpGroups == null) JS.SpaceGroupFinder.loadData (vwr, this);
if (opXYZ0 != null) {
return this.getGroupsWithOp (opXYZ0);
}uc = uc.getUnitCellMultiplied ();
this.filterGroups (bsGroups, uc);
withinCell = vwr.ms.getAtoms (1814695966, uc);
var extraAtoms = JU.BSUtil.copy (bsAtoms);
extraAtoms.andNot (withinCell);
withinCell.and (bsAtoms);
var nExtra = extraAtoms.cardinality ();
this.atoms =  new Array (bsAtoms.cardinality ());
System.out.println ("bsAtoms = " + bsAtoms);
for (var p = 0, i = bsAtoms.nextSetBit (0); i >= 0; i = bsAtoms.nextSetBit (i + 1), p++) {
var a = cartesians[i];
var type = a.getAtomicAndIsotopeNumber ();
(this.atoms[p] = Clazz.innerTypeInstance (JS.SpaceGroupFinder.SGAtom, this, null, type, i, a.getAtomName (), a.getOccupancy100 ())).setT (this.toFractional (a, uc));
}
var bsPoints = JU.BSUtil.newBitSet2 (0, this.nAtoms);
var uc0 = uc;
if (nExtra > 0) {
var packedAtoms =  new JU.BS ();
this.checkPackingAtoms (bsPoints, extraAtoms, 1, packedAtoms);
this.checkPackingAtoms (bsPoints, extraAtoms, 2, packedAtoms);
this.checkPackingAtoms (bsPoints, extraAtoms, 3, packedAtoms);
if (packedAtoms.cardinality () == nExtra) {
bsPoints.andNot (packedAtoms);
} else {
System.out.println ("Packing check failed! " + nExtra + " extra atoms " + extraAtoms + ", but " + packedAtoms.cardinality () + " found for " + packedAtoms);
bsPoints.clearAll ();
}}this.nAtoms = bsPoints.cardinality ();
uc0 = uc;
var isSupercell = false;
if (this.nAtoms > 0) {
for (var i = bsPoints.nextSetBit (0); i >= 0; i = bsPoints.nextSetBit (i + 1)) {
JU.SimpleUnitCell.unitizeDim (3, this.atoms[i]);
}
uc = this.checkSupercell (vwr, uc, bsPoints, 1, scaling);
uc = this.checkSupercell (vwr, uc, bsPoints, 2, scaling);
uc = this.checkSupercell (vwr, uc, bsPoints, 3, scaling);
isSupercell = (uc !== uc0);
if (isSupercell) {
if (scaling.x != 1) System.out.println ("supercell found; a scaled by 1/" + scaling.x);
if (scaling.y != 1) System.out.println ("supercell found; b scaled by 1/" + scaling.y);
if (scaling.z != 1) System.out.println ("supercell found; c scaled by 1/" + scaling.z);
}}n = bsPoints.cardinality ();
bsAtoms =  new JU.BS ();
var newAtoms =  new Array (n);
for (var p = 0, i = bsPoints.nextSetBit (0); i >= 0; i = bsPoints.nextSetBit (i + 1)) {
var a = this.atoms[i];
newAtoms[p++] = a;
if (isSupercell) {
a.setT (this.toFractional (cartesians[a.index], uc));
JU.SimpleUnitCell.unitizeDim (3, a);
}bsAtoms.set (this.atoms[i].index);
}
this.atoms = newAtoms;
this.nAtoms = n;
System.out.println ("bsAtoms(within cell) = " + bsAtoms);
bsPoints.clearAll ();
bsPoints.setBits (0, this.nAtoms);
bsPoints0 = JU.BS.copy (bsPoints);
var temp1 = JU.BS.newN (JS.SpaceGroupFinder.OP_COUNT);
var targeted = JU.BS.newN (this.nAtoms);
bsOps.setBits (1, JS.SpaceGroupFinder.OP_COUNT);
if (this.nAtoms == 0) {
bsGroups.clearBits (1, JS.SpaceGroupFinder.GROUP_COUNT);
bsOps.clearAll ();
}var uncheckedOps = JU.BS.newN (JS.SpaceGroupFinder.OP_COUNT);
var opsChecked = JU.BS.newN (JS.SpaceGroupFinder.OP_COUNT);
opsChecked.set (0);
var hasC1 = false;
for (var iop = bsOps.nextSetBit (1); iop > 0 && bsGroups.cardinality () > 0; iop = bsOps.nextSetBit (iop + 1)) {
var op = JS.SpaceGroupFinder.getOp (iop);
System.out.println ("\nChecking operation " + iop + " " + JS.SpaceGroupFinder.opXYZ[iop]);
System.out.println ("bsGroups = " + bsGroups);
System.out.println ("bsOps = " + bsOps);
nChecked++;
var isOK = true;
bsPoints.clearAll ();
bsPoints.or (bsPoints0);
targeted.clearAll ();
for (var i = bsPoints.nextSetBit (0); i >= 0; i = bsPoints.nextSetBit (i + 1)) {
bsPoints.clear (i);
var j = this.findEquiv (iop, op, i, bsPoints, this.pt, true);
if (j < 0) {
System.out.println ("failed op " + iop + " for atom " + i + " " + this.atoms[i].name + " " + this.atoms[i] + " looking for " + this.pt + "\n" + op);
isOK = false;
break;
}if (i != j) {
targeted.set (j);
}}
var myGroups = JS.SpaceGroupFinder.bsOpGroups[iop];
bsOps.clear (iop);
opsChecked.set (iop);
if (isOK) {
System.out.println ("OK!");
if (iop == 1) hasC1 = true;
targets.or (targeted);
System.out.println ("targeted=" + targeted);
System.out.println ("targets=" + targets);
bsGroups.and (myGroups);
temp1.setBits (1, JS.SpaceGroupFinder.OP_COUNT);
for (var i = bsGroups.nextSetBit (0); i >= 0; i = bsGroups.nextSetBit (i + 1)) {
temp1.and (JS.SpaceGroupFinder.bsGroupOps[i]);
}
uncheckedOps.or (temp1);
bsOps.andNot (temp1);
} else {
bsGroups.andNot (myGroups);
temp1.clearAll ();
for (var i = bsGroups.nextSetBit (0); i >= 0; i = bsGroups.nextSetBit (i + 1)) {
temp1.or (JS.SpaceGroupFinder.bsGroupOps[i]);
}
bsOps.and (temp1);
}}
n = bsGroups.cardinality ();
if (n == 0) {
bsGroups.set (hasC1 ? 1 : 0);
n = 1;
if (hasC1 && !asString) {
uncheckedOps.clearAll ();
uncheckedOps.set (1);
opsChecked.clearAll ();
targets.clearAll ();
bsPoints.or (bsPoints0);
}}isg = bsGroups.nextSetBit (0);
if (n == 1 && !asString) {
if (isg > 0) {
opsChecked.and (JS.SpaceGroupFinder.bsGroupOps[isg]);
uncheckedOps.and (JS.SpaceGroupFinder.bsGroupOps[isg]);
uncheckedOps.andNot (opsChecked);
uncheckedOps.or (JS.SpaceGroupFinder.bsGroupOps[isg]);
uncheckedOps.clear (0);
bsPoints.or (bsPoints0);
System.out.println ("test1 bspoints " + bsPoints.cardinality () + " " + bsPoints);
System.out.println ("test2 targets " + targets.cardinality () + " " + targets);
System.out.println ("test3 uchop= " + uncheckedOps.cardinality () + " " + uncheckedOps);
System.out.println ("test4 opsc= " + opsChecked.cardinality () + " " + opsChecked);
bsPoints.andNot (targets);
if (!this.checkBasis (uncheckedOps, bsPoints, targets)) {
isg = 0;
}System.out.println ("test2b targets " + targets.cardinality () + " " + targets);
System.out.println ("test1b points " + bsPoints.cardinality () + " " + bsPoints);
}if (isg == 0) targets.clearAll ();
}} catch (e) {
if (Clazz.exceptionOf (e, Exception)) {
e.printStackTrace ();
bsGroups.clearAll ();
} else {
throw e;
}
}
System.out.println ("checked " + nChecked + " operations; now " + n + " " + bsGroups + " " + bsOps);
for (var i = bsGroups.nextSetBit (0); i >= 0; i = bsGroups.nextSetBit (i + 1)) {
System.out.println (JS.SpaceGroup.nameToGroup.get (JS.SpaceGroupFinder.groupNames[i]));
}
if (n != 1) return null;
var sg = JS.SpaceGroup.nameToGroup.get (JS.SpaceGroupFinder.groupNames[isg]);
var name = sg.asString ();
uc.setSpaceGroupName (name);
System.out.println ("found " + name);
if (asString) return name;
var map = sg.dumpInfoObj ();
var basis = JU.BSUtil.copy (isg == 0 ? withinCell : bsAtoms);
for (var i = targets.nextSetBit (0); i >= 0; i = targets.nextSetBit (i + 1)) basis.clear (this.atoms[i].index);

System.out.println ("basis is " + basis.cardinality () + ": " + basis);
System.out.println ("unitcell is " + uc.getUnitCellInfo (true));
var bs1 = JU.BS.copy (bsPoints0);
bs1.andNot (targets);
this.dumpBasis (JS.SpaceGroupFinder.bsGroupOps[isg], bs1, bsPoints0);
map.put ("name", name);
map.put ("basis", basis);
map.put ("supercell", scaling);
var params = uc.getUnitCellParams ();
if (Float.isNaN (params[6])) System.arraycopy (params, 0, params =  Clazz.newFloatArray (6, 0), 0, 6);
map.put ("unitcell", params);
return map;
}, "JV.Viewer,JU.BS,~S,J.api.SymmetryInterface,~B");
Clazz.defineMethod (c$, "dumpBasis", 
 function (ops, bs1, bsPoints) {
}, "JU.BS,JU.BS,JU.BS");
Clazz.defineMethod (c$, "checkBasis", 
 function (uncheckedOps, bsPoints, targets) {
var n = uncheckedOps.cardinality ();
if (n == 0) return true;
var bs =  new JU.BS ();
bs.or (bsPoints);
System.out.println ("finishing check for basis for " + n + " operations");
for (var iop = uncheckedOps.nextSetBit (0); iop >= 0; iop = uncheckedOps.nextSetBit (iop + 1)) {
bs.or (bsPoints);
var op = JS.SpaceGroupFinder.getOp (iop);
for (var i = bs.nextSetBit (0); i >= 0; i = bs.nextSetBit (i + 1)) {
var j = this.findEquiv (-1, op, i, bs, this.pt, false);
if (j < 0) return false;
if (i != j) {
j = Math.max (i, j);
targets.set (j);
bs.clear (j);
}}
}
return true;
}, "JU.BS,JU.BS,JU.BS");
Clazz.defineMethod (c$, "filterGroups", 
 function (bsGroups, uc) {
var params = uc.getUnitCellParams ();
var isOrtho = false;
var isTet = false;
var isTri = false;
var isRhombo = false;
var isCubic = false;
var absame = this.approx0 (params[0] - params[1]);
var bcsame = this.approx0 (params[1] - params[2]);
if (params[3] == 90) {
if (params[4] == 90) {
if (absame && params[0] != params[1]) System.out.println ("OHOH");
isTri = (absame && this.approx000 (params[5] - 120));
if (params[5] == 90) {
isCubic = (absame && params[1] == params[2]);
isTet = (!isCubic && absame);
isOrtho = (!isCubic && !isTet);
}}} else if (absame && bcsame && params[3] == params[4] && params[4] == params[5]) {
isRhombo = true;
}bsGroups.setBits (0, 2);
var i0 = 2;
var i = 2;
while (true) {
i = JS.SpaceGroupFinder.scanTo (i, "16");
if (!isOrtho && !isTet && !isTri && !isRhombo && !isCubic) break;
i = JS.SpaceGroupFinder.scanTo (i, "75");
if (!isTet && !isTri && !isRhombo && !isCubic) break;
i = JS.SpaceGroupFinder.scanTo (i, "143");
if (!isTri && !isRhombo && !isCubic) break;
i0 = i;
for (; ; i++) {
var g = JS.SpaceGroupFinder.groupNames[i];
if (g.indexOf (":r") >= 0) {
if (!isRhombo) continue;
bsGroups.set (i);
}if (g.startsWith ("195")) {
if (isRhombo) return;
break;
}}
if (!isCubic) break;
bsGroups.setBits (2, i0);
i0 = i;
i = JS.SpaceGroupFinder.GROUP_COUNT;
break;
}
bsGroups.setBits (i0, i);
}, "JU.BS,J.api.SymmetryInterface");
c$.scanTo = Clazz.defineMethod (c$, "scanTo", 
 function (i, num) {
for (; ; i++) {
if (JS.SpaceGroupFinder.groupNames[i].startsWith (num)) break;
}
return i;
}, "~N,~S");
Clazz.defineMethod (c$, "getGroupsWithOp", 
 function (opXYZ0) {
var groups = null;
for (var i = JS.SpaceGroupFinder.opXYZ.length; --i >= 0; ) {
if (JS.SpaceGroupFinder.opXYZ[i].equals (opXYZ0)) {
groups = JS.SpaceGroupFinder.bsOpGroups[i];
System.out.println ("found for " + opXYZ0 + " " + groups);
break;
}}
if (groups != null) {
var ret =  new Array (groups.cardinality ());
for (var p = 0, i = groups.nextSetBit (0); i >= 0; i = groups.nextSetBit (i + 1)) {
ret[p++] = JS.SpaceGroup.getID (i);
}
return ret;
}return null;
}, "~S");
Clazz.defineMethod (c$, "toFractional", 
function (a, uc) {
this.pt.setT (a);
uc.toFractional (this.pt, false);
return this.pt;
}, "JM.Atom,J.api.SymmetryInterface");
c$.getOp = Clazz.defineMethod (c$, "getOp", 
 function (iop) {
var op = JS.SpaceGroupFinder.ops[iop];
if (op == null) {
JS.SpaceGroupFinder.ops[iop] = op =  new JS.SymmetryOperation (null, null, 0, iop, false);
op.setMatrixFromXYZ (JS.SpaceGroupFinder.opXYZ[iop], 0, false);
op.doFinalize ();
}return op;
}, "~N");
Clazz.defineMethod (c$, "checkPackingAtoms", 
 function (bsPoints, extraAtoms, abc, packedAtoms) {
var nextra = extraAtoms.cardinality ();
if (nextra == 0) return;
var nbase = 0;
var npacked = 0;
var f = 0;
for (var i = bsPoints.nextSetBit (0); i >= 0; i = bsPoints.nextSetBit (i + 1)) {
var a = this.atoms[i];
switch (abc) {
case 1:
f = a.x;
break;
case 2:
f = a.y;
break;
case 3:
f = a.z;
break;
}
if (this.approx01 (f)) {
nbase++;
} else if (this.approx01 (f - 1)) {
npacked++;
packedAtoms.set (i);
}}
if (nbase != npacked) {
bsPoints.clearAll ();
extraAtoms.clearAll ();
}}, "JU.BS,JU.BS,~N,JU.BS");
Clazz.defineMethod (c$, "checkSupercell", 
function (vwr, uc, bsPoints, abc, scaling) {
if (bsPoints.cardinality () == 0) return uc;
var minF = 2147483647;
var maxF = -2147483648;
var counts =  Clazz.newIntArray (101, 0);
for (var i = bsPoints.nextSetBit (0); i >= 0; i = bsPoints.nextSetBit (i + 1)) {
var a = this.atoms[i];
var type = a.typeAndOcc;
var name = a.name;
var b;
var f;
for (var j = bsPoints.nextSetBit (0); j >= 0; j = bsPoints.nextSetBit (j + 1)) {
if (j == i || (b = this.atoms[j]).typeAndOcc != type) continue;
this.pt.sub2 (b, a);
switch (abc) {
case 1:
if (this.approx0 (f = this.pt.x) || !this.approx0 (this.pt.y) || !this.approx0 (this.pt.z)) continue;
break;
case 2:
if (this.approx0 (f = this.pt.y) || !this.approx0 (this.pt.x) || !this.approx0 (this.pt.z)) continue;
break;
default:
case 3:
if (this.approx0 (f = this.pt.z) || !this.approx0 (this.pt.x) || !this.approx0 (this.pt.y)) continue;
break;
}
var n = this.approxInt (1 / f);
if (n == 0 || Clazz.doubleToInt (this.nAtoms / n) != 1 * this.nAtoms / n || n > 100) continue;
if (n > maxF) maxF = n;
if (n < minF) minF = n;
counts[n]++;
}
}
var n = maxF;
while (n >= minF) {
if (counts[n] > 0 && counts[n] == Clazz.doubleToInt ((n - 1) * this.nAtoms / n)) {
break;
}--n;
}
if (n < minF) return uc;
var oabc = uc.getUnitCellVectors ();
oabc[abc].scale (1 / n);
switch (abc) {
case 1:
scaling.x = n;
break;
case 2:
scaling.y = n;
break;
case 3:
scaling.z = n;
break;
}
uc = vwr.getSymTemp ().getUnitCell (oabc, false, "scaled");
var f = 0;
for (var i = bsPoints.nextSetBit (0); i >= 0; i = bsPoints.nextSetBit (i + 1)) {
switch (abc) {
case 1:
f = this.approxInt (n * this.atoms[i].x);
break;
case 2:
f = this.approxInt (n * this.atoms[i].y);
break;
case 3:
f = this.approxInt (n * this.atoms[i].x);
break;
}
if (f != 0) {
this.atoms[i] = null;
bsPoints.clear (i);
}}
this.nAtoms = bsPoints.cardinality ();
return uc;
}, "JV.Viewer,J.api.SymmetryInterface,JU.BS,~N,JU.P3");
Clazz.defineMethod (c$, "approx0", 
 function (f) {
return (Math.abs (f) < 0.001);
}, "~N");
Clazz.defineMethod (c$, "approx000", 
 function (f) {
return (Math.abs (f) < 1.0E-4);
}, "~N");
Clazz.defineMethod (c$, "approx0014", 
 function (f) {
return (Math.abs (f) < 0.0014);
}, "~N");
Clazz.defineMethod (c$, "approx01", 
 function (f) {
return (Math.abs (f) < 0.02);
}, "~N");
Clazz.defineMethod (c$, "approxInt", 
 function (finv) {
var i = Clazz.floatToInt (finv + 0.001);
return (Math.abs (finv - i) < 0.001 ? i : 0);
}, "~N");
Clazz.defineMethod (c$, "findEquiv", 
 function (iop, op, i, bsPoints, pt, andClear) {
var a = this.atoms[i];
pt.setT (a);
op.rotTrans (pt);
JU.SimpleUnitCell.unitizeDim (3, pt);
if (pt.distanceSquared (a) == 0) {
return i;
}var testiop = -99;
var type = a.typeAndOcc;
var name = a.name;
for (var j = this.nAtoms; --j >= 0; ) {
var b = this.atoms[j];
if (b.typeAndOcc != type) continue;
var d = b.distance (pt);
if (d * d < 1.96E-6 || (1 - d) * (1 - d) < 1.96E-6 && this.latticeShift (pt, b)) {
if (andClear) {
j = Math.max (i, j);
if (i != j) bsPoints.clear (j);
}return j;
}}
return -1;
}, "~N,JS.SymmetryOperation,~N,JU.BS,JU.P3,~B");
Clazz.defineMethod (c$, "latticeShift", 
 function (a, b) {
var is1 = (this.approx0014 (Math.abs (a.x - b.x) - 1) || this.approx0014 (Math.abs (a.y - b.y) - 1) || this.approx0014 (Math.abs (a.z - b.z) - 1));
if (is1) {
}return is1;
}, "JU.P3,JU.P3");
c$.main = Clazz.defineMethod (c$, "main", 
function (args) {
if (JS.SpaceGroupFinder.loadData (null,  new JS.SpaceGroupFinder ())) System.out.println ("OK");
}, "~A");
c$.loadData = Clazz.defineMethod (c$, "loadData", 
 function (vwr, me) {
try {
JS.SpaceGroupFinder.groupNames = JS.SpaceGroupFinder.getList (vwr, me, null, "sggroups_ordered.txt");
JS.SpaceGroupFinder.GROUP_COUNT = JS.SpaceGroupFinder.groupNames.length;
JS.SpaceGroupFinder.opXYZ = JS.SpaceGroupFinder.getList (vwr, me, null, "sgops_ordered.txt");
JS.SpaceGroupFinder.OP_COUNT = JS.SpaceGroupFinder.opXYZ.length;
var map = JS.SpaceGroupFinder.getList (vwr, me,  new Array (JS.SpaceGroupFinder.OP_COUNT), "sgmap.txt");
JS.SpaceGroupFinder.bsGroupOps =  new Array (JS.SpaceGroupFinder.GROUP_COUNT);
JS.SpaceGroupFinder.bsOpGroups =  new Array (JS.SpaceGroupFinder.OP_COUNT);
for (var j = 0; j < JS.SpaceGroupFinder.GROUP_COUNT; j++) JS.SpaceGroupFinder.bsGroupOps[j] = JU.BS.newN (JS.SpaceGroupFinder.OP_COUNT);

for (var i = 0; i < JS.SpaceGroupFinder.OP_COUNT; i++) {
var m = map[i];
JS.SpaceGroupFinder.bsOpGroups[i] = JU.BS.newN (JS.SpaceGroupFinder.GROUP_COUNT);
for (var j = 0; j < JS.SpaceGroupFinder.GROUP_COUNT; j++) {
if (m.charAt (j) == '1') {
JS.SpaceGroupFinder.bsGroupOps[j].set (i);
JS.SpaceGroupFinder.bsOpGroups[i].set (j);
}}
}
JS.SpaceGroupFinder.ops =  new Array (JS.SpaceGroupFinder.OP_COUNT);
return true;
} catch (e) {
if (Clazz.exceptionOf (e, Exception)) {
e.printStackTrace ();
return false;
} else {
throw e;
}
} finally {
if (JS.SpaceGroupFinder.rdr != null) try {
JS.SpaceGroupFinder.rdr.close ();
} catch (e) {
if (Clazz.exceptionOf (e, java.io.IOException)) {
} else {
throw e;
}
}
}
}, "JV.Viewer,~O");
c$.getList = Clazz.defineMethod (c$, "getList", 
 function (vwr, me, list, fileName) {
JS.SpaceGroupFinder.rdr = JV.FileManager.getBufferedReaderForResource (vwr, me, "J/symmetry/", "sg/" + fileName);
if (list == null) {
var l =  new JU.Lst ();
var line;
while ((line = JS.SpaceGroupFinder.rdr.readLine ()) != null) {
if (line.length > 0) {
l.addLast (line);
}}
l.toArray (list =  new Array (l.size ()));
} else {
for (var i = 0; i < list.length; i++) list[i] = JS.SpaceGroupFinder.rdr.readLine ();

}JS.SpaceGroupFinder.rdr.close ();
return list;
}, "JV.Viewer,~O,~A,~S");
c$.$SpaceGroupFinder$SGAtom$ = function () {
Clazz.pu$h(self.c$);
c$ = Clazz.decorateAsClass (function () {
Clazz.prepareCallback (this, arguments);
this.typeAndOcc = 0;
this.index = 0;
this.name = null;
Clazz.instantialize (this, arguments);
}, JS.SpaceGroupFinder, "SGAtom", JU.P3);
Clazz.makeConstructor (c$, 
function (a, b, c, d) {
Clazz.superConstructor (this, JS.SpaceGroupFinder.SGAtom, []);
this.typeAndOcc = a + 1000 * d;
this.index = b;
this.name = c;
}, "~N,~N,~S,~N");
c$ = Clazz.p0p ();
};
Clazz.defineStatics (c$,
"MAX_COUNT", 100,
"SLOP0014", 0.0014,
"MAX_DIST_2", 1.96E-6,
"SLOP02", 0.02,
"SLOP001", 0.001,
"SLOP0001", 0.0001,
"GROUP_COUNT", 0,
"OP_COUNT", 0,
"bsOpGroups", null,
"bsGroupOps", null,
"groupNames", null,
"opXYZ", null,
"ops", null,
"rdr", null);
});
